//=========================================================================
#define CSW_WEAPON		CSW_DEAGLE
new const g_weapon_entity[]=	"weapon_deagle"
new const g_weaponbox_model[]=	"models/w_deagle.mdl"

#define DAMAGE			1.1
#define RECOIL			0.5
#define RATE_OF_FIRE	0.2
#define RATE_OF_FIRE2	0.125
#define CLIP			7
#define AMMO			70
#define TIME_RELOAD		2.6

#define ANIM_IDLE		0
#define ANIM_SHOOT_1	2
#define ANIM_SHOOT_2	4
#define ANIM_RELOAD		6
#define ANIM_DRAW		7

#define WEAPON_KEY		2

#define BODY_NUMBER		9
new const MODELS[][]={
				"models/cs_adekvat/weapons/v_skull1.mdl",
				"models/cs_adekvat/weapons/p_skull1.mdl",
				"models/cs_adekvat/weapons/w_cso_weapons.mdl"
}
new const SOUNDS[][]= {
				"weapons/skull1-1.wav"
}
#define WEAPONLIST		"cs_adekvat/weapon_skull1_adekvat"
//=========================================================================
#include <amxmodx>
#include <fakemeta_util>
#include <hamsandwich>
#include <zombieplague>
new g_msgWeaponList,g_wpn_variables[10],g_index_shell,g_itemid
#define is_valid_weapon(%1) (pev_valid(%1)&&pev(%1, pev_impulse) == WEAPON_KEY)
public plugin_precache() {
		for(new i;i<=charsmax(MODELS);i++)precache_model(MODELS[i])
		for(new i;i<=charsmax(SOUNDS);i++)precache_sound(SOUNDS[i])
		g_index_shell=precache_model("models/pshell.mdl")
		register_clcmd(WEAPONLIST, "clcmd_weapon")
		register_message(78, "message_weaponlist")
		
		precache_generic("sprites/cs_adekvat/weapon_skull1_adekvat.txt")
		precache_generic("sprites/cs_adekvat/640hud64.spr")
		precache_generic("sprites/cs_adekvat/640hud2.spr")
		precache_sound("weapons/skull1_draw.wav")
		precache_sound("weapons/skull1_clipout.wav")
		precache_sound("weapons/skull1_clipin.wav")
}
public plugin_init() {
		register_forward(FM_CmdStart, "fm_cmdstart")
		register_forward(FM_SetModel, "fm_setmodel")
		register_forward(FM_UpdateClientData, "fm_updateclientdata_post", 1)
		register_forward(FM_PlaybackEvent, "fm_playbackevent")
		RegisterHam(Ham_Item_Deploy, g_weapon_entity, "ham_item_deploy_post",1)
		RegisterHam(Ham_Weapon_PrimaryAttack, g_weapon_entity, "ham_weapon_primaryattack")
		RegisterHam(Ham_Weapon_Reload, g_weapon_entity, "ham_weapon_reload")
		RegisterHam(Ham_Weapon_WeaponIdle, g_weapon_entity, "ham_weapon_idle")
		RegisterHam(Ham_Item_PostFrame, g_weapon_entity, "ham_item_postframe")
		RegisterHam(Ham_Item_AddToPlayer, g_weapon_entity, "ham_item_addtoplayer")
		RegisterHam(Ham_TraceAttack, "player", "ham_traceattack_post",1)
		RegisterHam(Ham_TraceAttack, "worldspawn", "ham_traceattack_post",1)
		RegisterHam(Ham_TraceAttack, "func_breakable", "ham_traceattack_post",1)
		RegisterHam(Ham_TraceAttack, "func_breakable", "fw_TraceAttack_Post", 1);
		RegisterHam(Ham_TraceAttack, "func_wall", "fw_TraceAttack_Post", 1);
		RegisterHam(Ham_TraceAttack, "func_door", "fw_TraceAttack_Post", 1);
		RegisterHam(Ham_TraceAttack, "func_plat", "fw_TraceAttack_Post", 1);
		RegisterHam(Ham_TraceAttack, "func_rotating", "fw_TraceAttack_Post", 1);
		RegisterHam(Ham_TraceAttack, "worldspawn", "fw_TraceAttack_Post", 1);
		RegisterHam(Ham_TraceAttack, "func_door_rotating", "fw_TraceAttack_Post", 1);
		RegisterHam(Ham_TakeDamage, "player", "ham_takedamage")
		g_msgWeaponList=get_user_msgid("WeaponList")
		g_itemid=	zp_register_extra_item("Skull-1", 0, ZP_TEAM_HUMAN)
}
public zp_buy_ammo_2(id)
{
	new iEnt = get_pdata_cbase(id , 373 , 5);
	
	if(!is_valid_weapon(iEnt)) 
		return;	

	zp_set_ammo_value(id, 7)
	zp_set_ammo_cost(id, 140)
	zp_set_ammo_max(id, 70)
}
public clcmd_weapon(id){engclient_cmd(id, g_weapon_entity); return PLUGIN_HANDLED;}
public message_weaponlist(msg_id,msg_dest,id)if(get_msg_arg_int(8)==CSW_WEAPON)for(new i=2;i<=9;i++)g_wpn_variables[i]=get_msg_arg_int(i)
public fm_cmdstart(id,uc_handle,seed){
	if(!is_user_alive(id))return
	static weapon_entity;weapon_entity=get_pdata_cbase(id,373,5)
	if(!is_valid_weapon(weapon_entity)) return
	if((get_uc(uc_handle,UC_Buttons)&IN_ATTACK2)&&get_pdata_float(id,83,5)<=0.0&&get_pdata_float(weapon_entity,46,4)<=0.0){
		static clip;clip=get_pdata_int(weapon_entity,51,4)
		new Float:push[3]
		pev(id,pev_punchangle,push)
		ExecuteHam(Ham_Weapon_PrimaryAttack, weapon_entity)
		if(clip<=get_pdata_int(weapon_entity,51,4))return
		emit_sound(id, CHAN_WEAPON, SOUNDS[0], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		play_weapon_animation(id, ANIM_SHOOT_2)
		push[0]+=random_float(-2.0, 2.0)
		push[1]+=random_float(-2.0, 2.0)
		push[2]+=random_float(-2.0, 2.0)
		set_pev(id,pev_punchangle,push)	
		set_pdata_float(weapon_entity,46,RATE_OF_FIRE2,4)
		set_pdata_float(weapon_entity, 48, 2.2, 4)
	}
}
public ham_takedamage(victim,inflictor,attacker, Float:damage) <FireBullets: Enabled>
{
	SetHamParamFloat(4,damage * DAMAGE)
	return HAM_OVERRIDE;
}
public ham_takedamage() <FireBullets: Disabled> { return HAM_IGNORED; }
public ham_takedamage() <> { return HAM_IGNORED; }
public fm_setmodel(model_entity,model[]){
	if(!pev_valid(model_entity)||!equal(model,g_weaponbox_model))return FMRES_IGNORED			
	static weap;weap=fm_find_ent_by_owner(-1,g_weapon_entity,model_entity)	
	if(!is_valid_weapon(weap))return FMRES_IGNORED	
	fm_entity_set_model(model_entity,MODELS[2])
	set_pev(model_entity,pev_body,BODY_NUMBER)
	return FMRES_SUPERCEDE
}
public fm_updateclientdata_post(id,SendWeapons,CD_Handle){
	if(get_cd(CD_Handle, CD_DeadFlag) != DEAD_NO) return;
	static weapon_ent; weapon_ent=get_pdata_cbase(id,373,5)
	if(!is_valid_weapon(weapon_ent)) return
	set_cd(CD_Handle, CD_flNextAttack, 999999.0)
}
public fm_playbackevent(flags,id){
	if(!is_user_alive(id))return FMRES_IGNORED
	static weapon_ent;weapon_ent=get_pdata_cbase(id, 373, 5)
	if(!is_valid_weapon(weapon_ent))return FMRES_IGNORED
	return FMRES_SUPERCEDE
}
public ham_item_deploy_post(weapon_ent){
	if(!is_valid_weapon(weapon_ent))return
	static id;id=get_pdata_cbase(weapon_ent,41,4)
	set_pev(id, pev_viewmodel2, MODELS[0]),set_pev(id, pev_weaponmodel2, MODELS[1])
	set_pdata_float(id, 83, 0.5, 5),set_pdata_float(weapon_ent, 48, 1.4, 4)
	play_weapon_animation(id, ANIM_DRAW)
}
public ham_weapon_primaryattack(weapon_entity) {
	if(!is_valid_weapon(weapon_entity))return HAM_IGNORED
	static id; id = get_pdata_cbase(weapon_entity, 41, 4)
	static clip;clip=get_pdata_int(weapon_entity,51,4)
	state FireBullets: Enabled;
	ExecuteHam(Ham_Weapon_PrimaryAttack, weapon_entity)
	state FireBullets: Disabled;
	if(clip<=get_pdata_int(weapon_entity,51,4))return HAM_IGNORED
	emit_sound(id, CHAN_WEAPON, SOUNDS[0], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

	play_weapon_animation(id, ANIM_SHOOT_1)
	
	set_pdata_float(weapon_entity,46,RATE_OF_FIRE,4)
	set_pdata_float(weapon_entity, 48, 1.2, 4)
	
	set_pdata_int(weapon_entity,57,g_index_shell,4) 
	set_pdata_float(id,111,get_gametime())
	
	return HAM_SUPERCEDE
}
public ham_weapon_reload(weapon_entity) {
	if(!is_valid_weapon(weapon_entity))return HAM_IGNORED
	static id; id = get_pdata_cbase(weapon_entity,41,4)
	static bpammo;bpammo=get_pdata_int(id,376+get_pdata_int(weapon_entity,49,4),5)
	static clip;clip=get_pdata_int(weapon_entity,51,4)
	if(!bpammo||clip==CLIP)return HAM_SUPERCEDE
	ExecuteHam(Ham_Weapon_Reload,weapon_entity)
	play_weapon_animation(id,ANIM_RELOAD)
	set_pdata_float(id,83,TIME_RELOAD,5)
	set_pdata_int(weapon_entity,54,1,4)
	return HAM_SUPERCEDE
}
public ham_weapon_idle(ent) {
	if(!is_valid_weapon(ent))return HAM_IGNORED
	static id; id = get_pdata_cbase(ent, 41, 4)
	if(get_pdata_float(ent, 48, 4)>0.0)return HAM_IGNORED
	play_weapon_animation(id, ANIM_IDLE)
	set_pdata_float(ent, 48, 5.0, 4)
	return HAM_SUPERCEDE
}
public ham_item_postframe(weapon_entity)  {
	if(!is_valid_weapon(weapon_entity)) return
	static id; id = get_pdata_cbase(weapon_entity,41,4)
	if(get_pdata_int(weapon_entity, 54, 4)&&get_pdata_float(id, 83, 5)<=0.0){		
		static bpammo;bpammo=get_pdata_int(id, 376 + get_pdata_int(weapon_entity, 49, 4), 5)
		static clip;clip=get_pdata_int(weapon_entity, 51, 4)
		for(new i=clip; i<CLIP;i++)if(bpammo)bpammo--,clip++	
		set_pdata_int(weapon_entity,54,0,4)
		set_pdata_int(weapon_entity,51,clip,4)
		set_pdata_int(id,376+get_pdata_int(weapon_entity,49,4),bpammo,5)
	}
}
public ham_item_addtoplayer(weapon_entity,id){
	switch(pev(weapon_entity, pev_impulse)){
		case 0: set_weaponlist(id, 0);
		case WEAPON_KEY: set_weaponlist(id, 1);
	}
}
public ham_traceattack_post(pEntity,attacker,Float:flDamage,Float:direction[3],ptr,damage_type) {
	if(!is_user_connected(attacker)||!(damage_type&DMG_BULLET))return
	static weapon_entity;weapon_entity=get_pdata_cbase(attacker, 373, 5)
	if(!is_valid_weapon(weapon_entity))return
	new Float:vecEnd[3],Float:vecPlane[3]
	get_tr2(ptr,TR_vecEndPos,vecEnd)
	get_tr2(ptr,TR_vecPlaneNormal,vecPlane)
	xs_vec_mul_scalar(vecPlane,5.0,vecPlane)
        if(!is_user_alive(pEntity)){
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(TE_GUNSHOTDECAL)
		engfunc(EngFunc_WriteCoord,vecEnd[0])
		engfunc(EngFunc_WriteCoord,vecEnd[1])
		engfunc(EngFunc_WriteCoord,vecEnd[2])
		write_short(pEntity)
		write_byte(random_num(41,45))
		message_end()
	}
}
public zp_extra_item_selected(id,itemid) {
	if(itemid!=g_itemid)return
	get_item(id)
}
public get_item(id)
{
	new Ent=give_skull1(id)
	set_pdata_int(id,376+get_pdata_int(Ent,49,4),AMMO,5)
}
public give_skull1(id){
	new Float:Origin[3]; pev(id, pev_origin, Origin)
	new wName[32],iItem=get_pdata_cbase(id, 367+2, 5);
	while (pev_valid(iItem)==2)pev(iItem,pev_classname,wName,31),engclient_cmd(id,"drop",wName),iItem=get_pdata_cbase(iItem, 42, 4)
	new iWeapon=engfunc(EngFunc_CreateNamedEntity,engfunc(EngFunc_AllocString,g_weapon_entity))
	if(!pev_valid(iWeapon)) return 0
	dllfunc(DLLFunc_Spawn, iWeapon)
	engfunc(EngFunc_SetOrigin, iWeapon, Origin)
	set_pev(iWeapon, pev_impulse, WEAPON_KEY)
	set_pdata_int(iWeapon, 51, CLIP, 4)
	new save = pev(iWeapon,pev_solid)
	dllfunc(DLLFunc_Touch,iWeapon,id)
	if(pev(iWeapon, pev_solid)!=save)return iWeapon
	engfunc(EngFunc_RemoveEntity,iWeapon)
	return 0
}
public fw_TraceAttack_Post(entity, attacker, Float:damage, Float:fDir[3], ptr, damagetype) <FireBullets: Enabled>
{
	if(!is_user_connected(attacker)) return HAM_IGNORED;
	static item; item = get_pdata_cbase(attacker, 373, 5);
	if(item <= 0 || !is_valid_weapon(item)) return HAM_IGNORED;

	static Float:vecEnd[3]; 
	get_tr2(ptr, TR_vecEndPos, vecEnd);
	
	engfunc(EngFunc_MessageBegin, MSG_PAS, SVC_TEMPENTITY, vecEnd, 0);
	write_byte(TE_GUNSHOTDECAL);
	engfunc(EngFunc_WriteCoord, vecEnd[0]);
	engfunc(EngFunc_WriteCoord, vecEnd[1]);
	engfunc(EngFunc_WriteCoord, vecEnd[2]);
	write_short(entity);
	write_byte(random_num(41, 45));
	message_end();
			
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) ;
	write_byte(TE_STREAK_SPLASH)
	engfunc(EngFunc_WriteCoord, vecEnd[0]);
	engfunc(EngFunc_WriteCoord, vecEnd[1]);
	engfunc(EngFunc_WriteCoord, vecEnd[2]);
	write_coord(random_num(-20, 20))
	write_coord(random_num(-20, 20))
	write_coord(random_num(-20, 20)) 
	write_byte(4)
	write_short(30)
	write_short(3)
	write_short(75)
	message_end() ;	
	
	return HAM_IGNORED;
}
public fw_TraceAttack_Post() <FireBullets: Disabled> { return HAM_IGNORED; }
public fw_TraceAttack_Post() <> { return FMRES_IGNORED; }
stock play_weapon_animation(id,sequence){
	set_pev(id,pev_weaponanim, sequence)
	message_begin(MSG_ONE_UNRELIABLE,SVC_WEAPONANIM,_,id)
	write_byte(sequence)
	write_byte(0)
	message_end()
}
stock set_weaponlist(id,num=0){
	message_begin(MSG_ONE,g_msgWeaponList,_,id)
	write_string(num?WEAPONLIST:g_weapon_entity) 
	for(new i=2;i<=9;i++)write_byte(g_wpn_variables[i]) 
	message_end()
}
